#
# "@(#) $Id: CDR.py,v 1.5 2004/07/21 17:54:18 duane Exp $"
#
# This work is released under the GNU GPL, version 2 or later.
#
import re
from backtick import backtick

_burnerDevices = None

def getBurnerDevices(rescan = False):
	global _burnerDevices
	if _burnerDevices==None or rescan:
		_burnerDevices = []
		devicePattern = re.compile('^\s*?(\d+),(\d+),(\d+)\s*?\d+\)\s+?\'(.+?)\'\s+?\'(.+?)\'')
		capPattern = re.compile('^\s+?Does write (.+?) media')
		speedPattern = re.compile('^\s+?Maximum write speed:.+?\(CD\s+?(\d+)x')
		try:
			deviceLines = backtick('cdrecord -scanbus | grep -v "*" | grep ","')
			for deviceLine in deviceLines.split('\n'):
				md = devicePattern.match(deviceLine)
				if md:
					dev = md.group(1)+','+md.group(2)+','+md.group(3)
					devName = md.group(4).strip()
					model = md.group(5).strip()
					capLines = backtick('cdrecord -prcap dev=%s' % dev)
					supports = []
					speed = 1
					for capLine in capLines.split('\n'):
						mc = capPattern.match(capLine)
						if mc:
							supports.append(mc.group(1))
						ms = speedPattern.match(capLine)
						if ms:
							speed = int(ms.group(1))
					if len(supports)>0:
						_burnerDevices.append({'Address':dev,'Manufacturer':devName,'Model':model,'Supports':supports,"MaxSpeed":speed})
		except: pass
	return _burnerDevices

def canBurn():
	return len(getBurnerDevices())>0

if __name__=='__main__':
	print getBurnerDevices()
