#
# "@(#) $Id: LDellTrackViewItem.py,v 1.3 2004/07/21 17:54:18 duane Exp $"
#
# This work is released under the GNU GPL, version 2 or later.
#
from kdeemul import *
from LCheckListViewItem import *
from LTrackViewItemObject import *
from LsongsPaths import *
from human import *
import time

def _get(a,b):
	if a==None: return b
	return a

_playingIcon = None
def playingIcon():
	global _playingIcon
	if _playingIcon==None:
		_playingIcon = QPixmap(art("labelcurrentplaying.png"))
	return _playingIcon

_pausedIcon = None
def pausedIcon():
	global _pausedIcon
	if _pausedIcon==None:
		_pausedIcon = QPixmap(art("labelcurrentpause.png"))
	return _pausedIcon

class LDellTrackViewItem(KListViewItem):
	def __init__(self,container,track):
		KListViewItem.__init__(self,container)
		self._track = track
		self.trackItem = LTrackViewItemObject(self)
		self.status = 'idle'
		self.trackKey = "%03d" % self._track.trackNum
		self.ripIcon = -1
		self.ripTime = -1
		self.loadTrackInfo()
		self.setDragEnabled(True)

	def die(self):
		self.trackItem.trackItem = None
		self.trackItem = None

	def key(self,column, ascending):
		if column==0:
			return self.trackKey
		else:
			return KListViewItem.key(self,column,ascending)

	def track(self):
		return self._track

	def trackID(self):
		return self._track.trackID

	def loadTrackInfo(self):
		#self.setText(1,str(self._track.trackNum))
		self.setText(1,_get(self._track.title,""))
		self.setText(2,humanDuration(self._track.totalTime))
		self.setText(3,_get(self._track.artist,""))
		self.setText(4,_get(self._track.album,""))
		self.setText(5,_get(self._track.genre,""))
		#self.setOn(self._track.enabled)
		self.setPlayingIcon()

	def contentsMouseDoubleClickEvent(self,event):
		self.play()

	def play(self):
		playlist = self.listView().playlist
		self._track.play(playlist)

	def doImport(self):
		self._track.doImport()
	
	def stateChange(self,value):
		self._track.enabled = bool(value)

	def changedAttribute(self,attribute,oldValue,newValue):
		if attribute in ['trackNum','title','artist','album','contentType','playStatus']:
			self.loadTrackInfo()
		
	def setIdleIcon(self):
		self.setPixmap(0,QPixmap())

	def setPlayingIcon(self):
		status = self._track.playStatus
		if self.status!=status:
			if status=='playing':
				self.setPixmap(0,playingIcon())
			elif status=='paused':
				self.setPixmap(0,pausedIcon())
			else:
				self.setPixmap(0,QPixmap())
			self.status = status
		
