#
# "@(#) $Id: LVolumeWidget.py,v 1.3 2004/07/21 17:54:18 duane Exp $"
#
# This work is released under the GNU GPL, version 2 or later.
#
from qt import *
from LMusicPlayer import *
from LsongsPaths import *
from LSettings import *

class LVolumeWidget(QWidget):
	def __init__(self,container = None):
		QWidget.__init__(self,container)
		self.buildControls()
		volume = LSettings.settings().get('Volume',50)
		self.volumeSlider.setValue(volume)
	
	def buildControls(self):
		hbox = QHBoxLayout(self)
		hbox.setSpacing(4)
		hbox.addItem(QSpacerItem(1,1,QSizePolicy.Expanding,QSizePolicy.Fixed))
		label = QLabel("",self)
		label.setPixmap(QPixmap(art("labelvolumelow.png")))
		hbox.addWidget(label)
		self.volumeSlider = QSlider(Qt.Horizontal,self)
		self.volumeSlider.setFixedWidth(100)
		self.volumeSlider.setRange(0,100)
		QObject.connect(self.volumeSlider,SIGNAL("valueChanged(int)"),self.volumeChanged)
		hbox.addWidget(self.volumeSlider)
		label = QLabel("",self)
		label.setPixmap(QPixmap(art("labelvolumehigh.png")))
		hbox.addWidget(label)
		hbox.addItem(QSpacerItem(1,1,QSizePolicy.Expanding,QSizePolicy.Fixed))
		QObject.connect(LMusicPlayer.singleton(),PYSIGNAL("volumeChanged"),self.gotVolumeChange)

	def volumeChanged(self,volume):
		LMusicPlayer.singleton().setVolume(volume,self)
	
	def gotVolumeChange(self,volume,fromObject):
		if fromObject!=self:
			self.volumeSlider.blockSignals(True)
			self.volumeSlider.setValue(volume)
			self.volumeSlider.blockSignals(False)
	
